gstreamermm 1.4.3

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gst::TaskPool Class Reference

A class representing a pool of GStreamer streaming threads. More...

Inheritance diagram for Gst::TaskPool:
[legend]
Collaboration diagram for Gst::TaskPool:
[legend]

## Public Types
typedef sigc::slot< void > | SlotPush
| For example, void on_do_push();. More...

## Public Member Functions
virtual | ~TaskPool ()
GstTaskPool* | gobj ()
| Provides access to the underlying C GObject. More...
const GstTaskPool* | gobj () const
| Provides access to the underlying C GObject. More...
GstTaskPool* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | prepare ()
gpointer | push (const SlotPush& slot)
| Start the execution of a new thread from pool. More...
void | join (gpointer id)
| Join a task and/or return it to the pool. More...
void | cleanup ()
| Wait for all tasks to be stopped. More...
virtual void | prepare_vfunc ()
| Virtual function which prepares the thread pool. More...
virtual void | cleanup_vfunc ()
| Virtual function to cleanup the thread pool. More...
virtual gpointer | push_vfunc (const SlotPush& slot)
| Virtual function which starts a new thread. More...
virtual void | join_vfunc (gpointer id)
| Virtual function to join a thread. More...
Public Member Functions inherited from Gst::Object
virtual | ~Object ()
GstObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GstObject* | gobj () const
| Provides access to the underlying C GObject. More...
GstObject* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | is_element () const
bool | is_element_factory () const
bool | is_pad () const
bool | is_pad_template () const
bool | is_bin () const
guint32 | get_flags () const
| Returns the entire set of flags for the object. More...
bool | set_name (const Glib::ustring& name)
| Sets the name of object, or gives object a guaranteed unique name (if name is `0`). More...
Glib::ustring | get_name () const
| Returns a copy of the name of object. More...
bool | set_parent (const Glib::RefPtr< Gst::Object >& parent)
| Sets the parent of object to parent. More...
Glib::RefPtr< Gst::Object > | get_parent ()
| Returns the parent of object. More...
Glib::RefPtr< const Gst::Object > | get_parent () const
| Returns the parent of object. More...
void | unparent ()
| Clear the parent of object, removing the associated reference. More...
bool | has_ancestor (const Glib::RefPtr< const Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
Glib::ustring | get_path_string ()
| Generates a string describing the path of object in the object hierarchy. More...
Glib::PropertyProxy < Glib::ustring > | property_name ()
| The name of the object. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| The name of the object. More...
Glib::SignalProxy2< void, const Glib::RefPtr< Object > &, GParamSpec* > | signal_deep_notify ()
int | get_refcount () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< TaskPool > | create ()
| Create a new default task pool. More...
Static Public Member Functions inherited from Gst::Object
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | check_uniqueness (const Glib::ListHandle< const Gst::Object >& list, const Glib::ustring& name)
| Checks to see if there is any object named name in list. More...

## Protected Member Functions
| TaskPool ()
Protected Member Functions inherited from Gst::Object
virtual void | on_deep_notify (const Glib::RefPtr< Object >& prop_object, GParamSpec* prop)
| This is a default handler for the signal signal_deep_notify(). More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gst::TaskPool > | wrap (GstTaskPool* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Object
Glib::RefPtr< Gst::Object > | wrap (GstObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

A class representing a pool of GStreamer streaming threads.

This object provides an abstraction for creating threads. The default implementation uses a regular Glib::ThreadPool to start tasks.

Subclasses can be made to create custom threads.

Last reviewed on 2009-04-23 (0.10.24)

## Member Typedef Documentation

typedef sigc::slot<void> Gst::TaskPool::SlotPush

For example, void on_do_push();.

## Constructor & Destructor Documentation

virtual Gst::TaskPool::~TaskPool | ( |  | ) |
| virtual

Gst::TaskPool::TaskPool | ( |  | ) |
| protected

## Member Function Documentation

void Gst::TaskPool::cleanup | ( |  | ) |

Wait for all tasks to be stopped.

This is mainly used internally to ensure proper cleanup of internal data structures in test suites.

MT safe.

virtual void Gst::TaskPool::cleanup_vfunc | ( |  | ) |
| virtual

Virtual function to cleanup the thread pool.

static Glib::RefPtr<TaskPool> Gst::TaskPool::create | ( |  | ) |
| static

Create a new default task pool.

The default task pool will use a regular Glib::ThreadPool for threads.

Returns
  A new Gst::TaskPool.

static GType Gst::TaskPool::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GstTaskPool* Gst::TaskPool::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GstTaskPool* Gst::TaskPool::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GstTaskPool* Gst::TaskPool::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gst::TaskPool::join | ( | gpointer | id | ) |

Join a task and/or return it to the pool.

id is the id obtained from push().

Parameters

  id | The id.

virtual void Gst::TaskPool::join_vfunc | ( | gpointer | id | ) |
| virtual

Virtual function to join a thread.

void Gst::TaskPool::prepare | ( |  | ) |

Exceptions

  Glib::Error. |

virtual void Gst::TaskPool::prepare_vfunc | ( |  | ) |
| virtual

Virtual function which prepares the thread pool.

Exceptions

  Glib::Error. |

gpointer Gst::TaskPool::push | ( | const SlotPush& | slot | ) |

Start the execution of a new thread from pool.

Parameters

  slot | The function to call.

Returns
  A pointer that should be used for the join() method. This pointer can be 0, you must check error to detect errors.

Exceptions

  Glib::Error. |

virtual gpointer Gst::TaskPool::push_vfunc | ( | const SlotPush& | slot | ) |
| virtual

Virtual function which starts a new thread.

Exceptions

  Glib::Error. |

## Friends And Related Function Documentation

Glib::RefPtr< Gst::TaskPool > wrap | ( | GstTaskPool * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gstreamermm/taskpool.h